create or replace view kc_emp_not_in_dept_tree
( state
, levell
, description
, icon
, parameters
, sequence1
, sequence2
, deptno
) 
as
with with_emp as
(
select   empno
,        ename
,        nvl(e.deptno, -100) deptno
,        dname
from	   emp     e
,        dept    d
where    e.deptno = d.deptno (+)
)
select   1
,        1
,        nvl(initcap(dname), 'Not assigned to a department')
,        'kc_node'
,        to_number(null)
,        nvl(dname, chr(1))
,        chr(1)
,        deptno
from     with_emp
group by dname, deptno
union all
select   0
,        2
,        initcap(ename)
,        'kc_emp_blue'
,        empno
,        nvl(dname, chr(1))
,        ename
,        deptno
from     with_emp
union all
select   0
,        1
,        'No employees in other departments'
,        ''
,        null
,        null
,        null
,        deptno
from	   dept d
where    not exists
         ( 
         select ''
         from	   with_emp   e
--         where    d.deptno = e.deptno
         )
/

create or replace view kc_emp_in_dept_tree
( state
, levell
, description
, icon
, parameters
, sequence1
, deptno
) 
as
with with_emp as
(
select   empno
,        ename
,        d.deptno
,        dname
from	   emp     e
,        dept    d
where    e.deptno = d.deptno
)
select   0
,        1
,        initcap(ename)
,        'kc_emp_green'
,        empno
,        ename
,        deptno
from     with_emp
union all
select   0
,        1
,        'No employees in department '||lower(dname)
,        ''
,        null
,        null
,        deptno
from	   dept d
where    not exists
         ( 
         select ''
         from	   with_emp   e
         where    d.deptno = e.deptno
         )
/


create or replace view kc_menu_odtug 
( mnu_name
, mnu_sequence
, mnu_block
, mnu_group
) 
as
select 'Sortable blocks'
,      1
,      'DEPT' 
,      'Gui items' 
from   dual
union all
select 'Trees'
,      2
,      'EMP' 
,      'Gui items' 
from   dual
union all
select 'Shuttle tree'
,      3
,      'CTRL_SHUTTLE' 
,      'Gui items' 
from   dual
union all
select 'Web util'
,      4
,      'WU' 
,      'Out of the box java'
from   dual
union all
select 'Buttons with icon'
,      5
,      'BUTTONS_ICON' 
,      'Java' 
from   dual
union all
select 'Chart'
,      6
,      'BEAN_CHART' 
,      'Java' 
from   dual
union all
select 'Zip file'
,      7
,      'ZIP' 
,      'Java'
from   dual
/

create or replace view kc_menu_amis 
( mnu_name
, mnu_sequence
, mnu_block
) 
as
select 'Sortable blocks'
,      1
,      'DEPT' 
from   dual
union all
select 'Multiselect tree'
,      3
,      'CTRL_TREE' 
from   dual
union all
select 'Web util'
,      4
,      'WU' 
from   dual
union all
select 'Buttons with icon'
,      5
,      'BUTTONS_ICON' 
from   dual
union all
select 'Chart'
,      6
,      'BEAN_CHART' 
from   dual
/
create or replace view kc_menu_odtug_tree
( state
, levell
, description
, icon
, parameters
, sequence1
, sequence2
) 
as
with with_mnu as
( select mnu_name
,        mnu_group
,        mnu_sequence
,        mnu_block
from     kc_menu_odtug
) 
select   1
,        1
,        initcap(mnu_group)
,        'kc_node'
,        ''
,        min(mnu_sequence)
,        0
from     with_mnu
group by mnu_group
union all
select   0
,        2
,        initcap(mnu_name)
,        'kc_menu'
,        mnu_block
,        min(mnu_sequence) over (partition by mnu_group)
,        mnu_sequence
from     with_mnu
/

create or replace view kc_emp_dept_tree
( state
, levell
, description
, icon
, parameters
, sequence1
, sequence2
) 
as
with with_emp as
(
select   empno
,        ename
,        e.deptno
,        nvl(dname, 'not assigned to department')  dept_desc
,        nvl(dname, chr(1))     dept_sequence
from	   emp     e
,        dept    d
where    e.deptno = d.deptno (+)
)
select   1
,        1
,        initcap(dept_desc)
,        'kc_node'
,        to_number(null)
,        dept_sequence
,        chr(1)
from     with_emp
group by dept_desc, dept_sequence
union all
select   0
,        2
,        initcap(ename)
,        case kc_emp_service.is_manager_c (empno) 
         when 'N' then 'kc_emp_blue'
         when 'Y' then 'kc_emp_green'
         else 'kc_emp_blue'
         end
,        empno
,        dept_sequence
,        ename
from     with_emp
/






