package kccharts;


import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.ChartFactory;
import org.jfree.data.general.*;
import org.jfree.data.jdbc.*;
import org.jfree.chart.plot.*;
import org.jfree.data.category.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.JPanel;
import java.sql.*;
import java.util.*;
import java.io.*;


public class EmpBarChart extends Panel
{
  private CardLayout cardLayout = new CardLayout();
  private JFreeChart chart;
  private ChartPanel chartPanel;
  private String url = new String("jdbc:oracle:thin:@localhost:1521");
  private String driver = new String("oracle.jdbc.driver.OracleDriver");
  private Connection connection;

  public void setConnection(String userName, String password, String databaseName)
  {
  try
    {
        Class.forName(this.driver);
    }
    catch (ClassNotFoundException e)
    {
    System.err.print ("ClassNotFoundException : ");
    System.err.println (e.getMessage());
    }
    
    try {
    System.out.println ("Voor connectie");
    this.connection = DriverManager.getConnection( this.url+":"+databaseName, userName, password);
    System.out.println ("Na connectie ");
    }
    catch (java.sql.SQLException e)
    {
    System.err.print ("Fout bij connectie : ");
    System.err.println (e.getMessage());
    }
  }

  public EmpBarChart()
  {
    System.out.println("Start initialisation");
    System.out.println("Connection set");
    DefaultCategoryDataset dataset = new DefaultCategoryDataset();
    //dataset.setValue (100, "X", "Y");
    //
    this.chart = ChartFactory.createBarChart
    ( ""
    , "Departments"
    , "# Employees "
    , dataset
    , PlotOrientation.VERTICAL
    , true
    , true
    , false
    ) ;
    Plot plot = this.chart.getPlot();
    plot.setNoDataMessage("No data with these criteria!");
    plot.setNoDataMessageFont(new Font("Serif", Font.PLAIN, 12));
    plot.setNoDataMessagePaint(Color.red);
    //
    this.chartPanel = new ChartPanel (this.chart);
    this.chartPanel.setVisible(true);
    this.setLayout(cardLayout);
    this.add(chartPanel, "Chart");
    System.out.println("Initialisation completed");
  }
    public void setBackgroundColor (String backGroundColor) 
    {
    System.out.println("Start set background color");

    if (backGroundColor.equalsIgnoreCase("L"))
      {
      chart.setBackgroundPaint (new Color (231,231,214));
      }
    else
      {
      chart.setBackgroundPaint (new Color (212,208,200));
      //chart.setBackgroundPaint (new Color (231,231,214));
      }
    System.out.println("Background color set");
    }
    public void showGraph() {
    try {
     System.out.println("Start showGraph");
     String statement = new String( "select lower(dname), count(*) aantal from emp e "
                                  +", dept d "
                                  +" where e.deptno = d.deptno " 
                                  +" group by dname "
                                  + "order by dname "
                                  );
    System.out.println (statement);          
    JDBCCategoryDataset dataset = new JDBCCategoryDataset
                                  ( this.connection
                                  , statement
                                  );
    CategoryPlot plot = (CategoryPlot)this.chart.getPlot();
    plot.setDataset(dataset);     

    // Put chart on panel
    this.chartPanel = new ChartPanel (this.chart);
    this.chartPanel.setVisible(true);
    this.setLayout(cardLayout);
    this.add(chartPanel, "Chart");
    }
    catch (java.sql.SQLException e)
    {
    System.err.print ("SQL Fout : ");
    System.err.println (e.getMessage());
    }    
     System.out.println("showGraph completed");
  }
    
  
  public static void main(String[] args) {
        EmpBarChart chart = new EmpBarChart();
        chart.setConnection("kc", "kc", "ontw");
        chart.setBackgroundColor ("L");
        chart.showGraph();
        JFrame f1 = new JFrame();
        f1.getContentPane().add(chart);
        f1.setSize(700, 300);
        f1.setVisible(true);
  }

}