package javautils;

import java.util.zip.*;
import java.io.*;
public class ZipDirectory 
{
   private static void zipFile (ZipOutputStream out, File myFile, int lengthMainDir) throws IOException
   {
    // Create a buffer for reading the file
    byte[] buf = new byte[1024];
    // Compress the files
    FileInputStream in = new FileInputStream(myFile);   
    // Add ZIP entry to output stream.
    String entryName = myFile.getAbsolutePath().substring(lengthMainDir);
    out.putNextEntry(new ZipEntry(entryName));     
    // Transfer bytes from the file to the ZIP file
    int len;
    while ((len = in.read(buf)) > 0) {
           out.write(buf, 0, len);
          }
    // Complete the entry
    out.closeEntry();
    in.close();
   }

   private static void zipDir (ZipOutputStream out, File myDir, int lengthMainDir) throws IOException
   {
    String[] filenames = myDir.list();   
    // Compress the files
    for (int i=0; i<filenames.length; i++) {
        String fileWithDir = myDir.getAbsolutePath()+java.io.File.separatorChar+filenames[i]; 
        File myFile = new File (fileWithDir);
        if (new File (fileWithDir).isDirectory())
         {
           zipDir (out, myFile, lengthMainDir); 
         }
        else
         {
           zipFile (out, myFile, lengthMainDir);
         }
    }    
   }
   public static void zipDir (String dirName, String zipFileName)
   {
    File myDir = new File(dirName);
    int posLastSeparator = dirName.lastIndexOf(java.io.File.separatorChar);
    int lengthMainDir = dirName.substring(posLastSeparator).length();
    // Create a buffer for reading the files
    try {
        // Create the ZIP file
        ZipOutputStream out = new ZipOutputStream(new FileOutputStream(zipFileName));
        if (myDir.isDirectory())
          { 
            zipDir (out, myDir, lengthMainDir);
          }
        else
          {
            zipFile (out, myDir, lengthMainDir);
          }

        // Complete the ZIP file
        out.close();
    } catch (IOException e) {
    e.printStackTrace();
    }
   }
   public static void unzipDir ( String zipFileName, String dirName)
   {
     byte[] buf = new byte[1024];
     int len;
     try {
       ZipInputStream in = new ZipInputStream(new FileInputStream(zipFileName));    
      // Get the first entry
      ZipEntry entry =in.getNextEntry();
      while (entry != null) { 
        // Open the output file
        String entryName = entry.getName();
        String outputFileName = dirName+java.io.File.separatorChar+entryName;
        System.out.println(outputFileName);
        String entryDirName = outputFileName.substring (0, outputFileName.lastIndexOf(java.io.File.separatorChar));
        System.out.println("Dir entry " +entryDirName);
        if (entryDirName != null) {
          boolean dirCreateSucces = new File(entryDirName).mkdirs();
        }

        OutputStream out = new FileOutputStream(outputFileName);
        // Transfer bytes from the ZIP file to the output file
        while ((len = in.read(buf)) > 0) {
            out.write(buf, 0, len);
        }
       // Close the streams
       out.close();
       entry =in.getNextEntry();
      }
      in.close();    
    } 
    catch (IOException e) {
    e.printStackTrace();
    }
   }
  public static void main (String[] args)
   {
   String inputDirName = new String ("C:"+java.io.File.separatorChar+"TEMP"+java.io.File.separatorChar+"testdir");
   String outputFileName = inputDirName+".zip";   
   File zipFile = new File (outputFileName);
   if (zipFile.exists()) 
      { 
      zipFile.delete();
      }  
    zipDir (inputDirName, outputFileName );
    //
    String outputDirName = new String ("C:"+java.io.File.separatorChar+"TEMP2");
    String inputFileName = outputFileName;
    unzipDir (inputFileName, outputDirName );    
   }
}